/********************************************************************
QuaterniongC_̉]
Cӂ̃xNgi_n_j]ƂāCCӂ̓_Cӂ̊px]

********************************************************************/

class Quaternion {
	//quaternion(w;x,y,z)`ŕ\
	//  w=qua[0]
	//  x=qua[1]
	//  y=qua[2]
	//  z=qua[3]
	//̃NXstatic֐ō쐬
	
	private static final double pi=3.14159265358979323846264338;
	
	//Q̃xNg̓ςvZ܂
	public static double calcInnerproduct(double[] lhvec3, double[] rhvec3) {
		return lhvec3[0]*rhvec3[0]+lhvec3[1]*rhvec3[1]+lhvec3[2]*rhvec3[2];
	}

	//Q̃xNg̓ςvZ܂@offsetŃxNg̊Jnvf܂
	public static double calcInnerproduct(double[] lhvec3, double[] rhvec3, int offset) {
		return lhvec3[offset]*rhvec3[offset]+lhvec3[offset+1]*rhvec3[offset+1]+lhvec3[offset+2]*rhvec3[offset+2];
	}

	//Q̃xNg̓ςvZ܂
	public static double calcInnerproduct4(double[] lhvec4, double[] rhvec4) {
		return lhvec4[0]*rhvec4[0]+lhvec4[1]*rhvec4[1]+lhvec4[2]*rhvec4[2]+lhvec4[3]*rhvec4[3];
	}

	//Q̃xNg̊OςvZ܂
	public static void calcExteriorproduct(double[] outprd3, double[] lhvec3, double[] rhvec3) {
		outprd3[0]=lhvec3[1]*rhvec3[2]-lhvec3[2]*rhvec3[1];
		outprd3[1]=lhvec3[2]*rhvec3[0]-lhvec3[0]*rhvec3[2];
		outprd3[2]=lhvec3[0]*rhvec3[1]-lhvec3[1]*rhvec3[0];
		//a1b2-b1a2   a1b2-a2b1
		//b0a2-a0b2   a2b0-a0b2
		//a0b1-b0a1   a0b1-a1b0
	}

	//Q̃xNg̊OςvZ܂@offsetŃxNg̊Jnvf܂
	public static void calcExteriorproduct(double[] outprd3, double[] lhvec3, double[] rhvec3, int offset) {
		outprd3[offset]  =lhvec3[offset+1]*rhvec3[offset+2]-lhvec3[offset+2]*rhvec3[offset+1];
		outprd3[offset+1]=lhvec3[offset+2]*rhvec3[offset]-lhvec3[offset]*rhvec3[offset+2];
		outprd3[offset+2]=lhvec3[offset]*rhvec3[offset+1]-lhvec3[offset+1]*rhvec3[offset];
	}

	//xNgvec3̑傫iΒljvZ܂
	public static double calcMagnitude(double[] vec3) {
		return Math.sqrt(vec3[0]*vec3[0]+vec3[1]*vec3[1]+vec3[2]*vec3[2]);
	}
	
	//xNgvec4̑傫iΒljvZ܂
	public static double calcMagnitude4(double[] vec4) {
		return Math.sqrt(vec4[0]*vec4[0]+vec4[1]*vec4[1]+vec4[2]*vec4[2]+vec4[3]*vec4[3]);
	}
	
	//2̑傫P̃xNgi_n_jvec3Ԃ̊px[rad]vZ܂B
	public static double calcAngle2normvec3(double[] lhvec3, double[] rhvec3) {
		double inprd=calcInnerproduct(lhvec3, rhvec3);
		return Math.acos(inprd);
	}
	
	//2̃xNgi_n_jvec3Ԃ̊px[rad]vZ܂B
	public static double calcAngleVec3(double[] lhvec3, double[] rhvec3) {
		double inprd=calcInnerproduct(lhvec3, rhvec3);
		double magl=calcMagnitude(lhvec3);
		double magr=calcMagnitude(rhvec3);
		return Math.acos(inprd/(magl*magr));
	}
	
	//2̃xNgi_n_jvec4Ԃ̊px[rad]vZ܂B
	public static double calcAngleVec4(double[] lhvec4, double[] rhvec4) {
		double inprd=calcInnerproduct4(lhvec4, rhvec4);
		double magl=calcMagnitude4(lhvec4);
		double magr=calcMagnitude4(rhvec4);
		return Math.acos(inprd/(magl*magr));
	}
	
	//ʒuxNgQuaternionɕϊ܂
	public static void makeQuaternionVec(double[] quaternion, double[] vec3) {
		quaternion[0]=0;
		quaternion[1]=vec3[0];
		quaternion[2]=vec3[1];
		quaternion[3]=vec3[2];
	}

	/*@̊֐͗prȂ
	//ʒuxNgQuaternionɕϊ܂
	public static void makeQuaternionVec(double[] quaternion, double[] vec3) {
		double mag=calcMagnitude(vec3);
		quaternion[0]=0;
		quaternion[1]=vec3[0]/mag;
		quaternion[2]=vec3[1]/mag;
		quaternion[3]=vec3[2]/mag;
	}
	*/
	
	//傫P̃xNgi_n_jtheta]Quaternioni̕Њj܂
	public static void makeQuaternionNormVec(double[] quaternion, double[] vec3, double theta) {
		double th2=theta/2;
		double sn=Math.sin(th2);
		double cs=Math.cos(th2);
		quaternion[0]=cs;
		quaternion[1]=sn*vec3[0];
		quaternion[2]=sn*vec3[1];
		quaternion[3]=sn*vec3[2];
	}

	//xNgi_n_jtheta]Quaternioni̕Њj܂
	public static void makeQuaternionVec(double[] quaternion, double[] vec3, double theta) {
		double mag=calcMagnitude(vec3);
		double th2=theta/2;
		double snm=Math.sin(th2)/mag;
		double cs=Math.cos(th2);
		quaternion[0]=cs;
		quaternion[1]=snm*vec3[0];
		quaternion[2]=snm*vec3[1];
		quaternion[3]=snm*vec3[2];
	}
	
	//Quaternion܂
	public static void conjugateQuaternion(double[] resultquaternion, double[] quaternion) {
		resultquaternion[0]=quaternion[0];
		resultquaternion[1]=-quaternion[1];
		resultquaternion[2]=-quaternion[2];
		resultquaternion[3]=-quaternion[3];
	}
	
	//Quaternion܂
	public static void conjugateQuaternion(double[] quaternion) {
		quaternion[1]=-quaternion[1];
		quaternion[2]=-quaternion[2];
		quaternion[3]=-quaternion[3];
	}
	
	//Quaternion|1{܂
	public static void complementQuaternion(double[] resultquaternion, double[] quaternion) {
		resultquaternion[0]=-quaternion[0];
		resultquaternion[1]=-quaternion[1];
		resultquaternion[2]=-quaternion[2];
		resultquaternion[3]=-quaternion[3];
	}
	
	//Quaternion|1{܂
	public static void complementQuaternion(double[] quaternion) {
		quaternion[0]=-quaternion[0];
		quaternion[1]=-quaternion[1];
		quaternion[2]=-quaternion[2];
		quaternion[3]=-quaternion[3];
	}
	
	//Quaternion̐ς܂B
	public static void multQuaternion(double[] resultqua, double[] lhqua, double[] rhqua) {
		double inprd=calcInnerproduct(lhqua, rhqua, 1);
		calcExteriorproduct(resultqua, lhqua, rhqua, 1);
		resultqua[0]=lhqua[0]*rhqua[0]-inprd;
		resultqua[1]+=lhqua[0]*rhqua[1]+rhqua[0]*lhqua[1];
		resultqua[2]+=lhqua[0]*rhqua[2]+rhqua[0]*lhqua[2];
		resultqua[3]+=lhqua[0]*rhqua[3]+rhqua[0]*lhqua[3];
	}

	//Quaternionresultvec3ɕϊ܂
	public static void convQuaternion2vector(double[] resultvecV3, double[] quaternion) {
		resultvecV3[0]=quaternion[1];
		resultvecV3[1]=quaternion[2];
		resultvecV3[2]=quaternion[3];
	}
	
	//ʒuxNgsourceV3xNgi_n_jaxisV3̎theta]āCʒuxNgdestinationV3܂
	//sourceV3,axisV3͕ύXȂ
	public static void makeRotpos(double[] destinationV3, double[] sourceV3, double[] axisV3, double theta) {
		double[] quasrc=new double[4];
		double[] quaaxs=new double[4];
		double[] quatmp=new double[4];
		double[] quares=new double[4];
		makeQuaternionVec(quasrc, sourceV3);
		makeQuaternionVec(quaaxs, axisV3, theta);
		multQuaternion(quatmp, quaaxs, quasrc);
		conjugateQuaternion(quaaxs);
		multQuaternion(quares, quatmp, quaaxs);
		convQuaternion2vector(destinationV3,quares);
	}
	
	//Quaternion̑~
	private static void interpolateQuaternion(double[] quares, double[] quabgn, double[] quaend, double t) {
		double theta=calcAngleVec4(quabgn, quaend);
		if (theta<-pi/2 || pi/2<theta) complementQuaternion(quaend);
		double sinth=Math.sin(theta);
		double rbgn=Math.sin((1-t)*theta)/sinth;
		double rend=Math.sin(t*theta)/sinth;
		quares[0]=rbgn*quabgn[0]+rend*quaend[0];
		quares[1]=rbgn*quabgn[1]+rend*quaend[1];
		quares[2]=rbgn*quabgn[2]+rend*quaend[2];
		quares[3]=rbgn*quabgn[3]+rend*quaend[3];
	}
	
	//Quaternion̐`
	private static void interpolateQuaternionLinear(double[] quares, double[] quabgn, double[] quaend, double t) {
		double u=1-t;
		quares[0]=u*quabgn[0]+t*quaend[0];
		quares[1]=u*quabgn[1]+t*quaend[1];
		quares[2]=u*quabgn[2]+t*quaend[2];
		quares[3]=u*quabgn[3]+t*quaend[3];
	}
	
	//ʒuxNgv3bgnʒuxNgv3end܂ł~ߎi_SjʒuxNgv3res߂
	//0<t<1    t=0Fv3bgn     t=1Fv3end
	//v3bgn,v3end͕ύXȂ
	public static void interpolateVector(double[] v3res, double[] v3bgn, double[] v3end, double t) {
		double[] v3axs= new double[3];
		calcExteriorproduct(v3axs, v3bgn, v3end);
		double theta=calcAngleVec3(v3bgn, v3end);
		double[] quabgn=new double[4];
		makeQuaternionVec(quabgn, v3axs, 0);
		double[] quaend=new double[4];
		makeQuaternionVec(quaend, v3axs, theta);
		double[] quatn=new double[4];
		interpolateQuaternion(quatn, quabgn, quaend, t);
		double[] quabgnpnt=new double[4];
		makeQuaternionVec(quabgnpnt, v3bgn);
		double[] quatmp=new double[4];
		double[] quares=new double[4];
		multQuaternion(quatmp, quatn, quabgnpnt);
		conjugateQuaternion(quatn);
		multQuaternion(quares, quatmp, quatn);
		convQuaternion2vector(v3res, quares);
	}
}

class sample3 {
	private static final double pi=3.141592653589793;
	
	public static void main(String args[]) {
		//xNg(1,1,1)(1,0,-1)̓ς0
		double[] vecA={1,1,1};
		double[] vecB={1,0,-1};
		double inp=Quaternion.calcInnerproduct(vecA,vecB);
		System.out.println("inp = "+inp);
		inp=Quaternion.calcInnerproduct(vecA,vecB,0);
		System.out.println("inp = "+inp);

		//xNg(1,0,0)(0,2,0)̊Oς(0,0,2)
		double[] vecC={1,0,0};
		double[] vecD={0,2,0};
		double[] vecD2={1,4,9};
		double[] exp=new double[3];
		Quaternion.calcExteriorproduct(exp,vecC,vecD);
		printVec3("exprd",exp);
		Quaternion.calcExteriorproduct(exp,vecC,vecD,0);
		printVec3("exprd",exp);
		Quaternion.calcExteriorproduct(exp,vecD,vecC);
		printVec3("exprdr",exp);
		Quaternion.calcExteriorproduct(exp,vecC,vecC);
		printVec3("exprd0",exp);
		Quaternion.calcExteriorproduct(exp,vecD2,vecD2);
		printVec3("exprd0",exp);
		
		//xNg(1,2,3)̑傫sqrt14=3.74
		double[] vecE={1,2,3};
		double mag=Quaternion.calcMagnitude(vecE);
		System.out.println("mag = "+mag);
		
		//xNg(1,1,0)(0,0,2)̊pxpi/2=1.57
		double[] vecF={1,1,0};
		double[] vecG={0,0,2};
		double angle=Quaternion.calcAngle2normvec3(vecF,vecG);
		System.out.println("angle = "+angle);
		System.out.println();

		//xŁC_(1,1,0)0x](1,1,0)𓾂͂B
		//xŁC_(1,1,0)30x](1,0.866,0.5)𓾂͂B
		//xŁC_(1,1,0)60x](1,0.5,0.866)𓾂͂B
		//xŁC_(1,1,0)90x](1,0,1)𓾂͂B
		double[] axisA={1,0,0};
		double[] pointA={1,1,0};
		double[] pointX=new double[3];
		Quaternion.makeRotpos(pointX, pointA, axisA, 0);
		printVec3("pointX(0)",pointX);
		Quaternion.makeRotpos(pointX, pointA, axisA, pi/6);
		printVec3("pointX(pi/6)",pointX);
		Quaternion.makeRotpos(pointX, pointA, axisA, pi/3);
		printVec3("pointX(pi/3)",pointX);
		Quaternion.makeRotpos(pointX, pointA, axisA, pi/2);
		printVec3("pointX(pi/2)",pointX);
		System.out.println();
		
		//(1,0,1)ŁC_(2,0,0)180x](0,0,2)𓾂͂B
		double[] axisB={1,0,1};
		double[] pointB={2,0,0};
		Quaternion.makeRotpos(pointX, pointB, axisB, pi);
		printVec3("pointX(pi)",pointX);
		System.out.println();
		
		//(0,1,1)ŁC_(0,3,0)180x](0,0,3)𓾂͂B
		double[] axisC={0,1,1};
		double[] pointC={0,3,0};
		Quaternion.makeRotpos(pointX, pointC, axisC, pi);
		printVec3("pointX(pi)",pointX);
		System.out.println();
		
		//_(1,0,0)_(0,1,0)܂ł~⊮
		double[] pointD={1,0,0};
		double[] pointE={0,1,0};
		for (int i=0; i<=20; i++) {
			double t=(double)i/20;
			Quaternion.interpolateVector(pointX, pointD, pointE, t);
			printVec3("pointX(interpolate)",pointX);
		}
		System.out.println();

		//_(1,0,0)_(0,0,1)܂ł~⊮
		double[] pointF={1,0,0};
		double[] pointG={0,0,1};
		for (int i=0; i<=20; i++) {
			double t=(double)i/20;
			Quaternion.interpolateVector(pointX, pointF, pointG, t);
			printVec3("pointX(interpolate)",pointX);
		}
		System.out.println();

		//_(0,1,0)_(0,0,1)܂ł~⊮
		double[] pointH={0,1,0};
		double[] pointI={0,0,1};
		for (int i=0; i<=20; i++) {
			double t=(double)i/20;
			Quaternion.interpolateVector(pointX, pointH, pointI, t);
			printVec3("pointX(interpolate)",pointX);
		}
		System.out.println();

		//_(1,0,0)_(0,1,1)܂ł~⊮
		//_(0,1,1)͑~ɂ͂Ȃ̂ŁC0,sqrt2,sqrt3ɂȂ
		double[] pointJ={1,0,0};
		double[] pointK={0,1,1};
		for (int i=0; i<=20; i++) {
			double t=(double)i/20;
			Quaternion.interpolateVector(pointX, pointJ, pointK, t);
			printVec3("pointX(interpolate)",pointX);
		}
		System.out.println();
	}
	
	private static void printVec3(String str, double[] vec) {
		System.out.println(str+" = ("+vec[0]+", "+vec[1]+", "+vec[2]+")");
	}
	private static void printVec4(String str, double[] vec) {
		System.out.println(str+" = ("+vec[0]+", "+vec[1]+", "+vec[2]+", "+vec[3]+")");
	}
}

/*
inp = 0.0
inp = 0.0
exprd = (0.0, 0.0, 2.0)
exprd = (0.0, 0.0, 2.0)
exprdr = (0.0, 0.0, -2.0)
exprd0 = (0.0, 0.0, 0.0)
exprd0 = (0.0, 0.0, 0.0)
mag = 3.7416573867739413
angle = 1.5707963267948966

pointX(0) = (1.0, 1.0, 0.0)
pointX(pi/6) = (1.0, 0.8660254037844387, 0.49999999999999994)
pointX(pi/3) = (1.0, 0.5000000000000002, 0.8660254037844386)
pointX(pi/2) = (1.0, 2.220446049250313E-16, 1.0)

pointX(pi) = (0.0, 1.7319121124709863E-16, 1.9999999999999996)

pointX(pi) = (-2.5978681687064796E-16, 0.0, 2.9999999999999996)

pointX(interpolate) = (1.0, 0.0, 0.0)
pointX(interpolate) = (0.9969173337331282, 0.07845909572784496, 0.0)
pointX(interpolate) = (0.987688340595138, 0.15643446504023087, 0.0)
pointX(interpolate) = (0.9723699203976766, 0.23344536385590542, 0.0)
pointX(interpolate) = (0.9510565162951536, 0.30901699437494745, 0.0)
pointX(interpolate) = (0.923879532511287, 0.3826834323650898, 0.0)
pointX(interpolate) = (0.8910065241883678, 0.4539904997395468, 0.0)
pointX(interpolate) = (0.8526401643540924, 0.5224985647159489, 0.0)
pointX(interpolate) = (0.8090169943749476, 0.5877852522924731, 0.0)
pointX(interpolate) = (0.7604059656000313, 0.6494480483301838, 0.0)
pointX(interpolate) = (0.7071067811865477, 0.7071067811865476, 0.0)
pointX(interpolate) = (0.6494480483301838, 0.760405965600031, 0.0)
pointX(interpolate) = (0.5877852522924734, 0.8090169943749476, 0.0)
pointX(interpolate) = (0.522498564715949, 0.8526401643540922, 0.0)
pointX(interpolate) = (0.45399049973954697, 0.8910065241883678, 0.0)
pointX(interpolate) = (0.38268343236508995, 0.9238795325112868, 0.0)
pointX(interpolate) = (0.3090169943749477, 0.9510565162951538, 0.0)
pointX(interpolate) = (0.23344536385590559, 0.9723699203976768, 0.0)
pointX(interpolate) = (0.156434465040231, 0.9876883405951379, 0.0)
pointX(interpolate) = (0.07845909572784521, 0.9969173337331281, 0.0)
pointX(interpolate) = (2.220446049250313E-16, 1.0, 0.0)

pointX(interpolate) = (1.0, 0.0, 0.0)
pointX(interpolate) = (0.9969173337331282, 0.0, 0.07845909572784496)
pointX(interpolate) = (0.987688340595138, 0.0, 0.15643446504023087)
pointX(interpolate) = (0.9723699203976766, 0.0, 0.23344536385590542)
pointX(interpolate) = (0.9510565162951536, 0.0, 0.30901699437494745)
pointX(interpolate) = (0.923879532511287, 0.0, 0.3826834323650898)
pointX(interpolate) = (0.8910065241883678, 0.0, 0.4539904997395468)
pointX(interpolate) = (0.8526401643540924, 0.0, 0.5224985647159489)
pointX(interpolate) = (0.8090169943749476, 0.0, 0.5877852522924731)
pointX(interpolate) = (0.7604059656000313, 0.0, 0.6494480483301838)
pointX(interpolate) = (0.7071067811865477, 0.0, 0.7071067811865476)
pointX(interpolate) = (0.6494480483301838, 0.0, 0.760405965600031)
pointX(interpolate) = (0.5877852522924734, 0.0, 0.8090169943749476)
pointX(interpolate) = (0.522498564715949, 0.0, 0.8526401643540922)
pointX(interpolate) = (0.45399049973954697, 0.0, 0.8910065241883678)
pointX(interpolate) = (0.38268343236508995, 0.0, 0.9238795325112868)
pointX(interpolate) = (0.3090169943749477, 0.0, 0.9510565162951538)
pointX(interpolate) = (0.23344536385590559, 0.0, 0.9723699203976768)
pointX(interpolate) = (0.156434465040231, 0.0, 0.9876883405951379)
pointX(interpolate) = (0.07845909572784521, 0.0, 0.9969173337331281)
pointX(interpolate) = (2.220446049250313E-16, 0.0, 1.0)

pointX(interpolate) = (0.0, 1.0, 0.0)
pointX(interpolate) = (0.0, 0.9969173337331282, 0.07845909572784496)
pointX(interpolate) = (0.0, 0.987688340595138, 0.15643446504023087)
pointX(interpolate) = (0.0, 0.9723699203976766, 0.23344536385590542)
pointX(interpolate) = (0.0, 0.9510565162951536, 0.30901699437494745)
pointX(interpolate) = (0.0, 0.923879532511287, 0.3826834323650898)
pointX(interpolate) = (0.0, 0.8910065241883678, 0.4539904997395468)
pointX(interpolate) = (0.0, 0.8526401643540924, 0.5224985647159489)
pointX(interpolate) = (0.0, 0.8090169943749476, 0.5877852522924731)
pointX(interpolate) = (0.0, 0.7604059656000313, 0.6494480483301838)
pointX(interpolate) = (0.0, 0.7071067811865477, 0.7071067811865476)
pointX(interpolate) = (0.0, 0.6494480483301838, 0.760405965600031)
pointX(interpolate) = (0.0, 0.5877852522924734, 0.8090169943749476)
pointX(interpolate) = (0.0, 0.522498564715949, 0.8526401643540922)
pointX(interpolate) = (0.0, 0.45399049973954697, 0.8910065241883678)
pointX(interpolate) = (0.0, 0.38268343236508995, 0.9238795325112868)
pointX(interpolate) = (0.0, 0.3090169943749477, 0.9510565162951538)
pointX(interpolate) = (0.0, 0.23344536385590559, 0.9723699203976768)
pointX(interpolate) = (0.0, 0.156434465040231, 0.9876883405951379)
pointX(interpolate) = (0.0, 0.07845909572784521, 0.9969173337331281)
pointX(interpolate) = (0.0, 2.220446049250313E-16, 1.0)

pointX(interpolate) = (1.0, 0.0, 0.0)
pointX(interpolate) = (0.9969173337331282, 0.05547895863492364, 0.05547895863492364)
pointX(interpolate) = (0.987688340595138, 0.11061587104123714, 0.11061587104123714)
pointX(interpolate) = (0.9723699203976766, 0.16507079981907166, 0.16507079981907166)
pointX(interpolate) = (0.9510565162951536, 0.21850801222441055, 0.21850801222441055)
pointX(interpolate) = (0.923879532511287, 0.27059805007309845, 0.27059805007309845)
pointX(interpolate) = (0.8910065241883678, 0.32101976096010304, 0.32101976096010304)
pointX(interpolate) = (0.8526401643540924, 0.3694622782708856, 0.3694622782708856)
pointX(interpolate) = (0.8090169943749476, 0.4156269377774534, 0.4156269377774534)
pointX(interpolate) = (0.7604059656000313, 0.4592291190026416, 0.4592291190026416)
pointX(interpolate) = (0.7071067811865478, 0.5, 0.5)
pointX(interpolate) = (0.6494480483301838, 0.5376882147304866, 0.5376882147304866)
pointX(interpolate) = (0.5877852522924734, 0.5720614028176844, 0.5720614028176844)
pointX(interpolate) = (0.522498564715949, 0.6029076421267909, 0.6029076421267909)
pointX(interpolate) = (0.453990499739547, 0.6300367553350504, 0.6300367553350504)
pointX(interpolate) = (0.38268343236508995, 0.6532814824381883, 0.6532814824381883)
pointX(interpolate) = (0.3090169943749477, 0.6724985119639574, 0.6724985119639574)
pointX(interpolate) = (0.2334453638559057, 0.6875693645350206, 0.6875693645350206)
pointX(interpolate) = (0.156434465040231, 0.6984011233337104, 0.6984011233337104)
pointX(interpolate) = (0.07845909572784521, 0.7049270069651074, 0.7049270069651074)
pointX(interpolate) = (2.220446049250313E-16, 0.7071067811865475, 0.7071067811865475)

*/

